package com.yl8timer.kqj.yl8timer.ctrl;

import java.io.BufferedOutputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.FilenameFilter;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.ResponseEntity;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.client.RestTemplate;

import com.yl8timer.kqj.yl8timer.entity.Command;
import com.yl8timer.kqj.yl8timer.entity.Device;
import com.yl8timer.kqj.yl8timer.entity.EnrollData;
import com.yl8timer.kqj.yl8timer.entity.FKDataHS100_GLog;
import com.yl8timer.kqj.yl8timer.entity.FKDataHS100_UserIdInfo;
import com.yl8timer.kqj.yl8timer.entity.FKDataHS101_GLog;
import com.yl8timer.kqj.yl8timer.entity.FKDataHS101_UserIdInfo;
import com.yl8timer.kqj.yl8timer.entity.FKWebTransBlockData;
import com.yl8timer.kqj.yl8timer.tools.Constant;
import com.yl8timer.kqj.yl8timer.tools.LogUtil;
import com.yl8timer.kqj.yl8timer.tools.MyUtil;

import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONObject;

@RestController
public class KqjController {

	private byte[] bytRequestBin;
	private byte[] bytRequestTotal;
	private LogUtil log;
	private String serverUrl = "http://192.168.4.222:8089";// 对应8小时 考勤接口

	private String defPath = "E:\\ylwork\\zwj\\f";
	private String defimgPath = "E:\\ylwork\\zwjimg\\";
	@Autowired
	private HttpServletResponse response;

	@Autowired
	private HttpServletRequest request;

	
//	@PostMapping(value = "/cmd")
//	public void cmd(@RequestParam String cmd, @RequestParam String devid, @RequestParam String json) {
//		Device dev = Device.getDevice(devid);
//		if (dev == null)
//			return;
//		switch (cmd) {
//		case Command.SET_TIME:
//			dev.addCmd(Command.SET_TIME, "{\"time\":\"" + MyUtil.GetFKTimeString14(new Date()) + "\"}");
//			break;
//		case Command.SET_USER_INFO:
//			JSONObject user = new JSONObject(json);
//			String username = user.getStr("user_name");
//			if (username == null || "".equals(username)) {
//				dev.addCmd(cmd, json);
//				return;
//			}
//			String userid = user.getStr("user_id");
//			try {
//				File f = new File(defPath + userid);
//				if (f.exists()) {
//					FileInputStream fis = new FileInputStream(f);
//					ByteArrayOutputStream bos = new ByteArrayOutputStream(1000);
//					byte[] bbb = new byte[1000];
//					int n;
//					while ((n = fis.read(bbb)) != -1) {
//						bos.write(bbb, 0, n);
//					}
//					fis.close();
//					byte[] bys = bos.toByteArray();
//					bos.close();
//					dev.addCmd(Command.SET_USER_INFO, bys);
//				} else {
//					dev.addCmd(cmd, json);
//				}
//			} catch (Exception e) {
//				e.printStackTrace();
//			}
//			break;
//		default:
//			dev.addCmd(cmd, json);
//			break;
//		}
//	}
//
//	//// 测试接口
//	@GetMapping(value = "/cmd/{cmd}")
//	public void cmd(@PathVariable Integer cmd) {
//		Device dev = Device.getDevice("E468648507402D2B");
//		if (dev == null)
//			return;
//		JSONObject vResultJson = new JSONObject();
//		switch (cmd) {
//		case 1: {
//			// SET_ENROLL_DATA
//			// SET_USER_INFO
//			// vResultJson.put("user_id", "002");
//			// vResultJson.put("user_name", "李桂强");
//			// vResultJson.put("user_privilege", "USER");
//			// dev.addCmd("SET_USER_INFO", vResultJson.toString());
//
//			vResultJson.put("user_id", "600119");
//			vResultJson.put("user_privilege", "MANAGE");
//			dev.addCmd("SET_USER_INFO", vResultJson.toString());
//
//			// if (ConvertEnrollDataInCmdParamBin(log, dev, cmd1))
//			// dev.addCmd(cmd1);
//			break;
//		}
//		case 2:
//			vResultJson.put("user_id", "600120");
//			String sFinal = vResultJson.toString();
//			dev.addCmd("DELETE_USER", vResultJson.toString());
//			break;
//		case 3:
//			// 更新时间
//			dev.addCmd("SET_TIME", "{\"time\":\"" + MyUtil.GetFKTimeString14(new Date()) + "\"}");
//
//			break;
//		case 5:
//			break;
//		case 4:
//			try {
//				FileInputStream fis = new FileInputStream(new File(defPath + "600119"));
//				ByteArrayOutputStream bos = new ByteArrayOutputStream(1000);
//				byte[] bbb = new byte[1000];
//				int n;
//				while ((n = fis.read(bbb)) != -1) {
//					bos.write(bbb, 0, n);
//				}
//				fis.close();
//				byte[] bys = bos.toByteArray();
//				bos.close();
//				dev.addCmd("SET_USER_INFO", bys);
//			} catch (Exception e) {
//				e.printStackTrace();
//			}
//
//			break;
//		// // 更新固件
//		// if (MakeUpdateFirmwareCmdParamBin(log, dev.getDevId(), dev.getFk_info(), cmd)
//		// == false) {
//		// cmd.setBytCmd(new byte[0]);
//		// cmd.setsResponse("ERROR_GET_PARAM");
//		// return;
//		// }
//		}
//	}

	// 设置指纹，用户
	private boolean ConvertEnrollDataInCmdParamBin(LogUtil log, Device dev, Command cmd) {
		final String csFuncName = "ConvertEnrollDataInCmdParamBin";

		log.i(csFuncName, "1 - ");

		try {
			JSONObject jobjDevInfo = new JSONObject(dev.getFk_info());
			int DstFpDataVer = jobjDevInfo.getInt("fp_data_ver");
			log.i(csFuncName, "1 - 1 - FpDataVer=" + DstFpDataVer);
			// 机器采用的指纹数据版本
			if (DstFpDataVer < 1 || DstFpDataVer > 10000) {
				// 版本错误
				return false;
			}
			Command innerCmd = new Command();
			String sCmdParam = GetStringFromBSCommBuffer(cmd.getBytCmd());
			if (sCmdParam.length() == 0) {
				log.e(csFuncName, "2 - 1.1 - ");
				return false;
			}
			JSONObject jobjCmdParam = new JSONObject(sCmdParam);

			// 远程进入 录入页面
			if (cmd.getCmdCode().equals("SET_ENROLL_DATA")) {
				log.i(csFuncName, "2 - 2 - ");
				int bkNo = jobjCmdParam.getInt("backup_number");
				if (bkNo > 9) {
					log.i(csFuncName, "2 - 2.1 - ");
					return true;
				}
				log.i(csFuncName, "2 - 3 - ");
				byte[] bytFpData = GetBinDataFromBSCommBinData(1, cmd.getBytCmd());
				if (bytFpData.length == 0) {
					log.e(csFuncName, "2 - 3.1 - ");
					return false;
				}
				log.i(csFuncName, "2 - 4 - DstFpDataVer :" + DstFpDataVer);
				innerCmd.clear();

				innerCmd.setBytCmd(sCmdParam);
				innerCmd.appendBinData(bytFpData);
				log.i(csFuncName, "2 - 6 - ");
				return true;
			} else if (cmd.getCmdCode().equals("SET_USER_INFO")) {
				int k, m;
				log.i(csFuncName, "3 - 2 - ");
				List<EnrollData> listEnrollData = new ArrayList<EnrollData>();
				String user_id;
				String user_name;
				String user_privilege;
				byte[] user_photo = new byte[0];

				try {
					user_id = jobjCmdParam.getStr("user_id");
					user_name = jobjCmdParam.getStr("user_name");
					user_privilege = jobjCmdParam.getStr("user_privilege");
					if (!jobjCmdParam.isNull("user_photo")) {
						log.i(csFuncName, "3 - 3 - ");
						String sTemp;
						sTemp = jobjCmdParam.getStr("user_photo");
						m = Integer.parseInt(sTemp.substring(4, sTemp.length()));
						if (m >= 1)
							user_photo = GetBinDataFromBSCommBinData(m, cmd.getBytCmd());
					}

					log.i(csFuncName, "3 - 4 - ");
					EnrollData ed;
					JSONObject jobjOneED;
					if (jobjCmdParam.containsKey("enroll_data_array") && !jobjCmdParam.isNull("enroll_data_array")) {
						JSONArray jarrEnrollData = jobjCmdParam.getJSONArray("enroll_data_array");
						for (k = 0; k < jarrEnrollData.size(); k++) {
							String sTemp;
							byte[] bytTemp;
							jobjOneED = jarrEnrollData.getJSONObject(k);
							ed = new EnrollData();
							ed.setBackupNumber(Integer.parseInt(jobjOneED.getStr("backup_number")));

							log.i(csFuncName, "3 - 5 - k=" + k);
							sTemp = jobjOneED.getStr("enroll_data");
							if (sTemp.length() < 5) {
								log.e(csFuncName, "3 - 5.1 - k=" + k);
								return false;
							}

							log.i(csFuncName, "3 - 6 - k=" + k);
							m = Integer.parseInt(sTemp.substring(4));
							if (m < 1) {
								log.e(csFuncName, "3 - 6.1 - k=" + k);
								return false;
							}

							log.i(csFuncName, "3 - 7 - k=" + k + " m=" + m);
							bytTemp = GetBinDataFromBSCommBinData(m, cmd.getBytCmd());
							ed.setBytData(bytTemp);
							listEnrollData.add(ed);
						}
					}
				} catch (Exception ex) {
					log.e(csFuncName, "3 - except - " + ex.toString());
					return false;
				}

				log.i(csFuncName, "3 - 11 - ");
				if (listEnrollData.size() == 0) {
					log.i(csFuncName, "3 - 11 - 1");
					return true;
				}

				log.i(csFuncName, "3 - 12 - ");
				JSONObject jobjCmdParamNew = new JSONObject();
				jobjCmdParamNew.put("user_id", user_id);
				jobjCmdParamNew.put("user_name", user_name);
				jobjCmdParamNew.put("user_privilege", user_privilege);

				log.i(csFuncName, "3 - 13 - ");
				JSONArray jarrED = new JSONArray();
				EnrollData ed1 = null;
				m = 1;
				for (k = 0; k < listEnrollData.size(); k++) {
					JSONObject jobjOneED = new JSONObject();
					ed1 = listEnrollData.get(k);
					jobjOneED.put("backup_number", ed1.getBackupNumber());
					String sTemp = "BIN_" + m;
					jobjOneED.put("enroll_data", sTemp);
					jarrED.put(jobjOneED);
					m++;
				}
				jobjCmdParamNew.put("enroll_data_array", jarrED);

				log.i(csFuncName, "3 - 14 - ");
				if (user_photo.length > 0)
					jobjCmdParamNew.put("user_photo", "BIN_" + m);

				log.i(csFuncName, "3 - 15 - ");
				sCmdParam = jobjCmdParamNew.toString();
				innerCmd.setBytCmd(sCmdParam);
				for (k = 0; k < listEnrollData.size(); k++) {
					ed1 = listEnrollData.get(k);
					log.i(csFuncName, "3 - 15.2 - size = " + ed1.getBytData().length);
					cmd.appendBinData(ed1.getBytData());
				}
				log.i(csFuncName, "3 - 16 - ");
				if (user_photo.length > 0)
					cmd.appendBinData(user_photo);

				log.i(csFuncName, "3 - 17 - ");
				return true;

			} else {
				log.i(csFuncName, "3 - 18 - ");
				return true;
			}
		} catch (Exception e) {
			log.e(csFuncName, "Except - 2 - " + e.toString());
			return false;
		}
	}

//	@PostMapping(value = "/")
	public void abc() throws UnsupportedEncodingException {
		Logoutput("--------------------1--------------------");

		String sRequestCode = "";
		String sTransId = "";
		byte[] bytEmpty = new byte[0];

		final String csFuncName = "Page_Load";

		request.setCharacterEncoding("UTF-8");
		response.setCharacterEncoding("UTF-8");
		response.setHeader("content-type", "text/html;charset=UTF-8");
		// 是否打印
		log = LogUtil.getInstance(true);
		try {

			sRequestCode = request.getHeader("request_code");
			Logoutput("======================================================================sRequestCode=>"
					+ sRequestCode);
			if (!MyUtil.isValidEngDigitString(sRequestCode)) {
				log.e(csFuncName, "Invalid request_code : " + sRequestCode);
				return;
			}
			sTransId = request.getHeader("trans_id");
			if (sTransId == null)
				sTransId = "";
			log.i(csFuncName, "1 - request_code : " + sRequestCode + " ,trans_id : " + sTransId);

			String sDevId = request.getHeader("dev_id");
			if (!MyUtil.isValidEngDigitString(sDevId)) {
				log.e(csFuncName, "error - Invalid dev_id : " + sDevId);
				return;
			}

			int lenContent = GetRequestStreamBytes(request);
			if (lenContent < 0) {
				log.e(csFuncName, "2.1" + lenContent);
				return;
			}

			// 块序号
			int nBlkNo = 0;
			if (request.getHeader("blk_no") != null)
				nBlkNo = Integer.parseInt(request.getHeader("blk_no"));

			int vRet;
			if (nBlkNo > 0) {
				vRet = AddBlockData(sDevId, nBlkNo, bytRequestBin);
				if (vRet != 0) {
					log.e(csFuncName, "3.0 - error - AddBlockData:" + vRet);
					SendResponseToClient("ERROR_ADD_BLOCK_DATA", sTransId, "", bytEmpty, response);
					return;
				}
				log.i(csFuncName, "3.1");

				SendResponseToClient("OK", sTransId, "", bytEmpty, response);
				return;
			} else if (nBlkNo < 0) {
				SendResponseToClient("ERROR_INVLAID_BLOCK_NO", sTransId, "", bytEmpty, response);
				return;
			} else {
				GetBlockDataAndRemove(sDevId);
				bytRequestTotal = ConcateByteArray(bytRequestTotal, bytRequestBin);
			}
			switch (sRequestCode) {
			case Constant.REQ_CODE_RECV_CMD:
				RemoveOldBlockStream();
				OnReceiveCmd(sDevId, sTransId, bytRequestTotal, response);
				break;
			case Constant.REQ_CODE_SEND_CMD_RESULT:
				OnSendCmdResult(sDevId, sTransId, bytRequestTotal, response, request);
				break;
			case Constant.REQ_CODE_REALTIME_GLOG:
				OnRealtimeGLog(sDevId, bytRequestTotal, response, request);
				break;
			case Constant.REQ_CODE_REALTIME_ENROLL:
				OnRealtimeEnrollData(sDevId, bytRequestTotal, response, request);
				break;
			case "":
				break;
			default:
				SendResponseToClient("ERROR_INVLAID_REQUEST_CODE", sTransId, "", bytEmpty, response);
				break;
			}
		} catch (Exception e) {
			log.e("Page_Load---->" + e.getMessage());
			e.printStackTrace();
		} finally {
		}

	}

	// 实时登记数据
	private void OnRealtimeEnrollData(String asDevId, byte[] abytRequest, HttpServletResponse response,
			HttpServletRequest request) {
		Logoutput("--------------------2--------------------");
		final String csFuncName = "Page_Load - realtime_enroll_data";
		String sRequest;
		String sResponse;
		byte[] bytRequest = abytRequest;
		System.err.println("aby:"+abytRequest.toString());
		try {
			log.i(csFuncName, "1");
			sRequest = GetStringFromBSCommBuffer(bytRequest);
			System.err.println("sq:"+sRequest);
			if (sRequest.length() == 0) {
				return;
			}
			log.i(csFuncName, "2");
			JSONObject jobjRequest = new JSONObject(sRequest);
			String sUserId = jobjRequest.getStr("user_id");
			log.i(csFuncName, "3");
			BufferedOutputStream bos = null;
			FileOutputStream fos = null;
			FileWriter fw = null;
			try {
				// fw=new FileWriter("E:\\ylwork\\ab3.txt");
				// fw.write(new String(bytRequest));
				fos = new FileOutputStream(new File(defPath + sUserId));
				bos = new BufferedOutputStream(fos);
				bos.write(bytRequest);

				// JSONObject vResultJson = new JSONObject();
				// vResultJson.put("asDevId", asDevId);
				// vResultJson.put("asUserId", sUserId);
				// vResultJson.put("abytUserData",bytRequest);
				// String sFinal = vResultJson.toString();
				// String url = serverUrl+"/kqz/sauserregdata";
				// HttpHeaders headers = new HttpHeaders();
				// MultiValueMap<String, Object> params = new LinkedMultiValueMap<>();
				// params.add("json", sFinal);
				// RestTemplate restTemplate = new RestTemplate();
				// HttpEntity httpEntity = new HttpEntity(params, headers);
				// restTemplate.postForEntity(url, httpEntity, String.class);
				sResponse = "OK";
			} catch (Exception ex) {
				sResponse = "ERROR_DB_ACCESS";
			} finally {
				if (bos != null)
					bos.close();
				if (fos != null)
					fos.close();
				if (fw != null)
					fw.close();
			}
			response.addHeader("response_code", sResponse);
			response.setContentType("application/octet-stream");
			response.addHeader("Content-Length", "0");
			response.flushBuffer();
			log.i(csFuncName, "4");
			
		} catch (Exception ex) {
			log.e(csFuncName, "Except - 1 - " + ex.getMessage());
			return;
		}
	}

	// 实时打卡数据
	private void OnRealtimeGLog(String asDevId, byte[] abytRequest, HttpServletResponse response,
			HttpServletRequest request) {
		Logoutput("--------------------3--------------------");
		final String csFuncName = "Page_Load - realtime_glog";

		String sRequest = "";
		String sResponse;
		byte[] bytRequest = abytRequest;
		byte[] bytLogImage = new byte[0];

		try {
			log.i(csFuncName, "1------------------>");

			Command cmd = new Command();
			GetStringAnd1stBinaryFromBSCommBuffer(bytRequest, cmd);
			sRequest = cmd.getJsonstr();
			bytLogImage = cmd.getBytCmd();
			System.err.println("sQequest:"+sRequest);
			if (sRequest.length() == 0) {
				log.e(csFuncName, "1-- length=" + sRequest.length());
				return;
			}

			log.i(csFuncName, "2");

			String sUserId;
			String sVerifyMode;
			String sIOMode;
			String sIOTime;
			// String sLogImg;
			String sFKBinDataLib;

			JSONObject jobjRequest = new JSONObject(sRequest);
			log.i(csFuncName, "2-1");
			try {
				sFKBinDataLib = jobjRequest.getStr("fk_bin_data_lib");
			} catch (Exception e) {
				log.e(csFuncName, "2-- sFKBinDataLib.length=0");
				response.addHeader("response_code", "ERROR_INVALID_LIB_NAME");
				response.setContentType("application/octet-stream");
				response.addHeader("Content-Length", "0");
				response.flushBuffer();
				return;
			}
			log.i(csFuncName, "2-2");
			sUserId = jobjRequest.getStr("user_id");
			sVerifyMode = jobjRequest.getStr("verify_mode");
			sIOMode = jobjRequest.getStr("io_mode");
			sIOTime = jobjRequest.getStr("io_time");
			log.i(csFuncName, "2-3");
			log.i(csFuncName, "2" + "user_id = " + sUserId + "  sIOTime = " + sIOTime);
			if (sFKBinDataLib == "FKDataHS101") {
				sIOMode = FKDataHS101_GLog.GetInOutModeString(Integer.parseInt(sIOMode));
				sVerifyMode = FKDataHS101_GLog.GetVerifyModeString(Integer.parseInt(sVerifyMode));
			}

			else if (sFKBinDataLib == "FKDataHS100") {
				sIOMode = FKDataHS100_GLog.GetInOutModeString(Integer.parseInt(sIOMode));
				sVerifyMode = FKDataHS100_GLog.GetVerifyModeString(Integer.parseInt(sVerifyMode));
			}

			log.i(csFuncName, "3");

			sResponse = InsertRealtimeGLog(log, asDevId, sUserId, sVerifyMode, sIOMode, sIOTime, bytLogImage);

			response.addHeader("response_code", sResponse);
			response.setContentType("application/octet-stream");
			response.addHeader("Content-Length", "0");
			response.flushBuffer();

			log.i(csFuncName, "4");

		} catch (Exception ex) {
			log.e(csFuncName, "Except - 1 - " + ex.getMessage());
			return;
		}
	}

	// 实时打卡数据保存
	public String InsertRealtimeGLog(LogUtil log, String asDevId, String asUserId, String asVerifyMode, String asIOMode,
			String asIOTime, byte[] abytLogImage) {
		final String csFuncName = "InsertRealtimeGLog";
		String sStdIoTime = MyUtil.ConvertFKTimeToNormalTimeString(asIOTime);

		log.i(csFuncName, "1 - " + sStdIoTime);

		try {
			log.i(csFuncName, "2");

			if (!MyUtil.isValidEngDigitString(asUserId))
				return "ERROR_INVALID_USER_ID";
			if (MyUtil.IsNullOrEmptyString(asVerifyMode))
				return "ERROR_INVALID_VERIFY_MODE";
			if (MyUtil.IsNullOrEmptyString(asIOMode))
				return "ERROR_INVALID_IO_MODE";
			if (!MyUtil.IsValidTimeString(sStdIoTime))
				return "ERROR_INVALID_IO_TIME";
		} catch (Exception e) {
			log.e(csFuncName, "2 - error");
			return "ERROR_INVALID_LOG";
		}

		try {
			log.i(csFuncName, "3");

			log.i(csFuncName, "4");

			// String strSql;
			// strSql = "INSERT INTO kqjg_realtime_glog";
			// strSql = strSql + "(update_time, device_id, user_id, verify_mode, io_mode,
			// io_time)VALUES('";
			// strSql = strSql + TimeToString(new Date()) + "',?,?,?,?,?)";
			// String[] params = new
			// String[]{asDevId,asUserId,asVerifyMode,asIOMode,sStdIoTime};
			// DBUtil.update(strSql, params);
			/***********************************************************
			 * 考勤机打卡---开始
			 ********************************************************************************************/
			// KqjgRealtimeGlog glog = KqjgRealtimeGlog.builder().build();
			// glog.setUpdateTime(TimeToString(new Date()));
			// glog.setDeviceId(asDevId);
			// glog.setUserId(asUserId);//打卡用户id
			// glog.setVerifyMode(asVerifyMode);//打卡方式 1：指纹 20：人脸
			// glog.setIoMode(asIOMode);
			// glog.setIoTime(sStdIoTime);//打卡时间
			// glog.insertOrUpdate();
			// TODO
			System.err.println("asDevId:"+asDevId);
			System.err.println("asUserId:"+asUserId);
			System.err.println("asVerifyMode:"+asVerifyMode);
			System.err.println("asIOMode:"+asIOMode);
			System.err.println("asIOTime:"+asIOTime);
			/*********************************************************************
			 * 考勤机打卡---结束
			 ********************************************************************************************/
//			final String uri = serverUrl+"/kqz/punchclock/" + asDevId + "/" + asUserId + "/" + asVerifyMode
//					+ "/0/" + sStdIoTime;
//			RestTemplate restTemplate = new RestTemplate();
//			String result = restTemplate.getForObject(uri, String.class);

			JSONObject vResultJson = new JSONObject();
			vResultJson.put("asDevId", asDevId);
			vResultJson.put("asUserId", asUserId);
			vResultJson.put("asVerifyMode", asVerifyMode);
			vResultJson.put("sStdIoTime", sStdIoTime);
			String sFinal = vResultJson.toString();

//			String url = serverUrl + "/kqz/punchclock";
//			HttpHeaders headers = new HttpHeaders();
//			MultiValueMap<String, Object> params = new LinkedMultiValueMap<>();
//			params.add("json", sFinal);
//			RestTemplate restTemplate = new RestTemplate();
//			HttpEntity httpEntity = new HttpEntity(params, headers);
//			ResponseEntity<String> request = restTemplate.postForEntity(url, httpEntity, String.class);

			log.i(csFuncName, "5");

			if (SaveLogImageToFile(log, asDevId, asUserId, asIOTime, abytLogImage) != 0) {
				log.e(csFuncName, "Error to save log image");
				return "ERROR_SAVE_LOG_IMAGE";
			}

			log.i(csFuncName, "6");

			return "OK";
		} catch (Exception ex) {
			log.e(csFuncName, "Except - 1 - " + ex.getMessage());
			return "ERROR_DB_ACCESS";
		}
	}

	// 保存图片
	private int SaveLogImageToFile(LogUtil log, String asDevId, String asUserId, String asIOTime, byte[] abytLogImage) {
		final String csFuncName = "SaveLogImageToFile";
		String sLogImgFolder;

		try {
			log.i(csFuncName, "0");
			if (abytLogImage.length < 1)
				return 0;
			
			log.i(csFuncName, "2");
			// config
			File f = new File(defimgPath);
			sLogImgFolder = f.getParentFile().getAbsolutePath() + File.separator + asIOTime.substring(0, 8);
			f = new File(sLogImgFolder);
			if (!f.exists())
				f.mkdir();

			log.i(csFuncName, "3 - " + sLogImgFolder);

			FileOutputStream fs = new FileOutputStream(
					sLogImgFolder + File.separator + asUserId + "_" + asIOTime + ".jpg");
			fs.write(abytLogImage, 0, abytLogImage.length);
			fs.flush();
			fs.close();

			log.i(csFuncName, "4");
			return 0;
		} catch (Exception ex) {
			log.e(csFuncName, "Except - " + ex.getMessage());
			return -100;
		}
	}

	private void OnSendCmdResult(String asDevId, String sTransId, byte[] abytRequest, HttpServletResponse response,
			HttpServletRequest request) {
		Logoutput("--------------------4--------------------");
		final String csFuncName = "Page_Load - send_cmd_result";

		byte[] bytCmdResult = abytRequest;
		String sReturnCode;

		log.i(csFuncName, "1");

		try {
			log.i(csFuncName, "2 - trans_id:" + sTransId);

			Command cmd = new Command();
			// 重启
			// if (CheckResetCmd(log, asDevId, cmd)) {
			// log.i(csFuncName, "2.1");
			// SendResponseToClient("RESET_FK", sTransId, "", bytEmpty, response);
			// return;
			// }
			// 取消命令
			// if (IsCancelledCmd(log, asDevId, sTransId)) {
			// log.i(csFuncName, "2.2");
			// SendResponseToClient("ERROR_CANCELED", sTransId, "", bytEmpty, response);
			// return;
			// }

			log.i(csFuncName, "3");

			sReturnCode = request.getHeader("cmd_return_code").toString();

			SetCmdResult(log, sTransId, asDevId, sReturnCode, bytCmdResult, cmd);

			log.i(csFuncName, "4");

			SendResponseToClient(cmd.getsResponse(), cmd.getTransId(), cmd.getCmdCode(), cmd.getBytCmd(), response);

			log.i(csFuncName, "5");
		} catch (Exception ex) {
			log.e(csFuncName, "Except - 1 - " + ex.toString());
			return;
		}
	}

	private void OnReceiveCmd(String asDevId, String asTransId, byte[] abytRequest, HttpServletResponse response) {

		Logoutput("--------------------5--------------------");
		final String csFuncName = "Page_Load - receive_cmd";

		String sRequest;
		byte[] bytRequest = abytRequest;

		try {
			log.i(csFuncName, "2");

			sRequest = GetStringFromBSCommBuffer(bytRequest);
			if (sRequest.length() == 0) {
				return;
			}
			Device dev = Device.addDevice(asDevId, sRequest);
			log.i(csFuncName, "3 - DevName=" + dev.getFk_name() + ", DevTime=" + dev.getFk_time() + ", DevInfo="
					+ dev.getFk_info());
			// 检查命令
			// Command cmd = new Command(sTransId, sCmdCode, new byte[0], sResponse);
			// ReceiveCmd(log, dev, cmd);
			Command cmd = dev.getCmd();
			log.i(csFuncName, "4");
			SendResponseToClient(cmd.getsResponse(), cmd.getTransId(), cmd.getCmdCode(), cmd.getBytCmd(), response);

			log.i(csFuncName, "5");

		} catch (Exception ex) {
			log.i(csFuncName, "Except - 1 - " + ex.toString());
			// ex.printStackTrace();
			return;
		}
	}

	private int GetRequestStreamBytes(HttpServletRequest request) {
		Logoutput("--------------------6--------------------");
		int lenContent = request.getContentLength();
		if (lenContent < 1)
			return 0;
		InputStream streamIn;
		byte[] bytRecv = new byte[lenContent];
		try {
			streamIn = request.getInputStream();
			int lenRead = 0, readlen = 0;
			while ((readlen = streamIn.read(bytRecv, lenRead, 1024)) != -1) {
				lenRead += readlen;
			}
			// lenRead = streamIn.read(bytRecv, 0, lenContent);
			if (lenRead != lenContent) {
				return -1;
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		bytRequestBin = bytRecv;
		return lenContent;
	}

	private void RemoveOldBlockStream() {
		Logoutput("--------------------7--------------------");
		Date dtCur = new Date();
		try {
			List<String> listDevIdKey = new ArrayList<String>();
			FKWebTransBlockData app_val_blk;
			Iterator<Entry<String, FKWebTransBlockData>> iter = Constant.Application.entrySet().iterator();
			while (iter.hasNext()) {
				Map.Entry<String, FKWebTransBlockData> entry = (Map.Entry<String, FKWebTransBlockData>) iter.next();
				String sKey = entry.getKey();
				if (!sKey.equalsIgnoreCase("key_dev_"))
					continue;
				app_val_blk = entry.getValue();

				if (dtCur.getTime() - app_val_blk.TmLastModified.getTime() > 1000 * 60 * 30) {
					listDevIdKey.add(sKey);
				}
			}
			for (int i = 0; i < listDevIdKey.size(); i++) {
				Constant.Application.remove(listDevIdKey.get(i));
			}
		} catch (Exception e) {
			log.e(e.getMessage());
		}
	}

	private int GetBlockDataAndRemove(String asDevId) {
		Logoutput("--------------------8--------------------");
		bytRequestTotal = new byte[0];

		if (asDevId.length() == 0)
			return -1;
		try {
			String app_key;

			app_key = "key_dev_" + asDevId;
			FKWebTransBlockData app_val_blk = (FKWebTransBlockData) Constant.Application.get(app_key);
			if (app_val_blk == null) {
				log.i("GetBlockDataAndRemove->", "app_val_blk == null");
				return 0;
			}
			bytRequestTotal = Arrays.copyOf(app_val_blk.getAbytBlkData(), app_val_blk.getAbytBlkData().length);
			Constant.Application.remove(app_key);

			return 0;
		} catch (Exception e) {
			return -11;
		}
	}

	private int AddBlockData(String asDevId, int anBlkNo, byte[] abytBlkData) {
		Logoutput("--------------------9--------------------");
		if (asDevId.length() == 0)
			return -1; // -1 :

		if (anBlkNo < 1)
			return -1;

		if (abytBlkData.length == 0)
			return -1;

		try {
			String app_key;

			app_key = "key_dev_" + asDevId;

			if (anBlkNo == 1) {
				FKWebTransBlockData app_val_blk = (FKWebTransBlockData) Constant.Application.get(app_key);
				if (app_val_blk == null) {
					app_val_blk = new FKWebTransBlockData();
					Constant.Application.put(app_key, app_val_blk);
				} else {
					Constant.Application.remove(app_key);
					app_val_blk = new FKWebTransBlockData();
					Constant.Application.put(app_key, app_val_blk);
				}
				app_val_blk.LastBlockNo = 1;
				app_val_blk.setAbytBlkData(abytBlkData);
			} else {
				FKWebTransBlockData app_val_blk = (FKWebTransBlockData) Constant.Application.get(app_key);
				if (app_val_blk == null) {
					return -2;
				}
				if (app_val_blk.LastBlockNo != anBlkNo - 1) {
					return -3;
				}
				app_val_blk.LastBlockNo = anBlkNo;
				app_val_blk.setAbytBlkData(abytBlkData);
			}

			return 0;
		} catch (Exception e) {
			return -11;
		}
	}

	private void SendResponseToClient(String asResponseCode, String asTransId, String asCmdCode, byte[] abytCmdParam,
			HttpServletResponse response) {
		Logoutput("--------------------10--------------------");
		response.addHeader("response_code", asResponseCode);
		response.addHeader("trans_id", asTransId);
		response.addHeader("cmd_code", asCmdCode);

		response.setContentType("application/octet-stream");
		response.addHeader("Content-Length", String.valueOf(abytCmdParam.length));
		try {
			if (abytCmdParam.length > 0) {
				OutputStream streamOut = response.getOutputStream();
				streamOut.write(abytCmdParam, 0, abytCmdParam.length);
				streamOut.close();
			}
			response.flushBuffer();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public String GetStringFromBSCommBuffer(byte[] abytBSComm) {
		if (abytBSComm.length < 4)
			return "";
		try {
			String sRet;

			int lenText = MyUtil.byte2int(abytBSComm);
			if (lenText > abytBSComm.length - 4)
				return "";

			if (lenText == 0)
				return "";

			if (abytBSComm[4 + lenText - 1] == 0) // if last value of string buufer is 0x0
				sRet = MyUtil.byte2String(abytBSComm, 4, lenText - 1);
			else
				sRet = MyUtil.byte2String(abytBSComm, 4, lenText);

			return sRet;
		} catch (Exception e) {
			return "";
		}
	}

	public byte[] ConcateByteArray(byte[] abytDest, byte[] abytSrc) {
		int len_dest = abytDest.length + abytSrc.length;
		if (abytSrc.length == 0)
			return abytDest;
		byte[] bytTmp = new byte[len_dest];
		System.arraycopy(abytDest, 0, bytTmp, 0, abytDest.length);
		System.arraycopy(abytSrc, 0, bytTmp, abytDest.length, abytSrc.length);
		return bytTmp;
	}

	// 更新固件
	private boolean MakeUpdateFirmwareCmdParamBin(LogUtil log, String devId, String asDevInfo, Command cmd) {
		final String csFuncName = "MakeUpdateFirmwareCmdParamBin";

		if (!cmd.getCmdCode().equals("UPDATE_FIRMWARE"))
			return true;

		log.i(csFuncName, "1 - ");

		FileInputStream fs = null;
		try {
			JSONObject jobjDevInfo = new JSONObject(asDevInfo);
			final String sPrefix = jobjDevInfo.getStr("firmware_filename");

			log.i(csFuncName, "2 - prefix:" + sPrefix);
			// config
			File f = new File("G:/Temp/BSFirmware/");
			log.i(csFuncName, "3 - firmware file Dir:" + f.getAbsolutePath());
			File[] FirmwareFiles = f.listFiles(new FilenameFilter() {
				@Override
				public boolean accept(File dir, String name) {
					if (name.startsWith(sPrefix) && name.endsWith(".bin"))
						return true;
					return false;
				}
			});

			if (FirmwareFiles == null || FirmwareFiles.length == 0) {
				// String sSql = "UPDATE kqjg_fkcmd_trans SET
				// return_code='ERROR_NO_FIRMWARE_FILE', status='CANCELLED', update_time = NOW()
				// WHERE trans_id='" + cmd.getTransId() + "'";
				// DBUtil.update(sSql, null);

				// KqjgFkcmdTrans trans =
				// KqjgFkcmdTrans.builder().returnCode("ERROR_NO_FIRMWARE_FILE").status("CANCELLED").updateTime(TimeToString(new
				// Date())).build();
				// UpdateWrapper<KqjgFkcmdTrans> userUpdateWrapper = new UpdateWrapper<>();
				// userUpdateWrapper.eq("trans_id", cmd.getTransId());
				// trans.update(userUpdateWrapper);
				return false;
			}

			log.i(csFuncName, "4 - firmware file:" + FirmwareFiles[0].getName());

			byte[] bytFirmwareBin = new byte[(int) FirmwareFiles[0].length()];
			fs = new FileInputStream(FirmwareFiles[0]);
			int offset = 0;
			int numRead = 0;
			while (numRead >= 0) {
				if (offset < bytFirmwareBin.length)
					break;
				numRead = fs.read(bytFirmwareBin, offset, bytFirmwareBin.length - offset);
				offset += numRead;
			}
			log.i(csFuncName, "5 - ");

			String sFileTitle = FirmwareFiles[0].getName();
			String sCmdParam = "{\"firmware_file_name\":\"" + sFileTitle + "\",\"firmware_bin_data\":\"BIN_1\"}";
			cmd.setBytCmd(sCmdParam);
			cmd.appendBinData(bytFirmwareBin);
			return true;
		} catch (Exception e) {
			log.e(csFuncName, "Exception : " + e.getMessage());
			return false;
		} finally {
			if (fs != null)
				try {
					fs.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
		}
	}

	public byte[] GetBinDataFromBSCommBinData(int anOrder, byte[] bytBSComm) {
		byte[] bytEmpty = new byte[0];

		try {
			// Convert SQLSever Data types to C# data types
			// SQLSever Data type (varbinary) <-> C# data type (byte [])
			Logoutput("bytBSComm = " + bytBSComm.length);
			if (bytBSComm.length < 4)
				return bytEmpty;

			if (anOrder < 0 || anOrder > 255)
				return bytEmpty;

			int orderBin;
			int posBin;
			int lenBin;
			int lenText = MyUtil.byte2int(bytBSComm);
			Logoutput("lenText = " + lenText);
			if (lenText > bytBSComm.length - 4)
				return bytEmpty;

			posBin = 4 + lenText;
			orderBin = 0;
			while (true) {
				Logoutput("posBin = " + posBin);
				if (posBin > bytBSComm.length - 4)
					return bytEmpty;

				lenBin = MyUtil.byte2int(bytBSComm, posBin);
				Logoutput("lenBin = " + lenBin);
				Logoutput("comparelen = " + (bytBSComm.length - posBin - 4));
				if (lenBin > bytBSComm.length - posBin - 4)
					return bytEmpty;

				orderBin++;
				if (orderBin == anOrder)
					break;

				posBin = posBin + 4 + lenBin;
			}

			byte[] bytRet = new byte[lenBin];
			System.arraycopy(bytBSComm, posBin + 4, bytRet, 0, lenBin);
			Logoutput("bytRet = " + bytRet.length);
			return bytRet;
		} catch (Exception e) {
			Logoutput("err");
			return bytEmpty;
		}
	}

	public void SetCmdResult(LogUtil log, String asTransId, String asDevId, String asReturnCode, byte[] abytCmdResult,
			Command cmd) {
		final String csFuncName = "SetCmdResult";
		log.i(csFuncName, "0 - trans_id:" + asTransId + ", dev_id:" + asDevId);
		log.i(csFuncName, "1");
		try {
			// Thread.sleep(10000);
			log.i(csFuncName, "2");
			if (SaveCmdResultLogData(log, asTransId, asDevId, abytCmdResult) == false) {
				cmd.setsResponse("ERROR_DB_SAVE_LOG");
				return;
			}

			if (SaveUserIdList(log, asTransId, asDevId, abytCmdResult) == false) {
				cmd.setsResponse("ERROR_DB_SAVE_USER_ID_LIST");
				return;
			}
			// pstmt = sqlConn.prepareStatement("{call dbo.usp_set_cmd_result(?,?,?,?)}");
			// pstmt = sqlConn.prepareStatement("call usp_set_cmd_result(?,?,?,?)");
			// pstmt.setString(1, asDevId);
			// pstmt.setString(2, asTransId);
			// pstmt.setString(3, asReturnCode);
			// pstmt.setBytes(4, abytCmdResult);
			// pstmt.execute();

			// kqjgfkcmdtransmapper.call(asDevId,asTransId,asReturnCode,abytCmdResult);
			log.i(csFuncName, "3");

			cmd.setsResponse("OK");
			return;
		} catch (Exception e) {
			log.e(csFuncName, "Except - 1 - " + e.toString());
			cmd.setsResponse("ERROR_DB_ACCESS");
			return;
		}
	}

	// 保存user id list
	private boolean SaveUserIdList(LogUtil log, String asTransId, String asDevId, byte[] abytCmdResult) {
		final String csFuncName = "SaveUserIdList";

		log.i(csFuncName, "1");
		log.i(csFuncName, "2" + " astrans_id = " + asTransId);
		log.i(csFuncName, "3");
		String sFKDataLib = "";

		String sJson;
		byte[] bytUserIdList;
		Command cmd = new Command();
		Logoutput("sFKDataLib->" + sFKDataLib);
		GetStringAnd1stBinaryFromBSCommBuffer(abytCmdResult, cmd);
		sJson = cmd.getJsonstr();
		bytUserIdList = cmd.getBytCmd();
		if (sJson.length() == 0)
			return false;

		Logoutput("sJson->" + sJson);
		log.i(csFuncName, "4");
		int cntUserId, sizeOneUserId;
		try {
			JSONObject jobjLogInfo = new JSONObject(sJson);
			cntUserId = jobjLogInfo.getInt("user_id_count");
			sizeOneUserId = jobjLogInfo.getInt("one_user_id_size");
			if (bytUserIdList.length < cntUserId * sizeOneUserId)
				return false;

			log.i(csFuncName, "5");

			if (!"FKDataHS101".equalsIgnoreCase(sFKDataLib) && !"FKDataHS100".equalsIgnoreCase(sFKDataLib)) {
				log.e(csFuncName, "error - 1");
				return false;
			}

			if (sizeOneUserId != 8)
				return false;
			log.i(csFuncName, "6 - HS101");
			// String sSqlTemp = "DELETE FROM " + csTblUserId + " WHERE trans_id='" +
			// asTransId +
			// "' AND device_id='" + asDevId + "'";
			// DBUtil.update(sSqlTemp, null);

			// KqjgFkcmdTransCmdResultUserIdList.builder().build().delete(
			// new
			// QueryWrapper<KqjgFkcmdTransCmdResultUserIdList>().lambda().eq(KqjgFkcmdTransCmdResultUserIdList::getTransId,
			// asTransId)
			// .eq(KqjgFkcmdTransCmdResultUserIdList::getDeviceId, asDevId));
			int k;
			byte[] bytOneUserId = new byte[sizeOneUserId];
			byte[] bytEnrolledFlag;
			for (k = 0; k < cntUserId; k++) {
				int nEnrollDataCount = 0;

				System.arraycopy(bytUserIdList, k * sizeOneUserId, bytOneUserId, 0, sizeOneUserId);
				if ("FKDataHS101".equalsIgnoreCase(sFKDataLib)) {
					FKDataHS101_UserIdInfo usrid = new FKDataHS101_UserIdInfo(bytOneUserId);
					String sUserId = String.valueOf(usrid.UserId);
					bytEnrolledFlag = usrid.GetBackupNumberEnrolledFlag();
					for (int bkn = 0; bkn < bytEnrolledFlag.length; bkn++) {
						if (bytEnrolledFlag[bkn] == 1) {
							nEnrollDataCount++;
							// sSqlTemp = "INSERT INTO " + csTblUserId;
							// sSqlTemp += "(trans_id, device_id, user_id, backup_number)";
							// sSqlTemp += "VALUES('" + asTransId + "', '";
							// sSqlTemp += asDevId + "', '";
							// sSqlTemp += sUserId + "', ";
							// sSqlTemp += bkn + ")";
							// DBUtil.update(sSqlTemp, null);
							// KqjgFkcmdTransCmdResultUserIdList glog =
							// KqjgFkcmdTransCmdResultUserIdList.builder().build();
							// glog.setTransId(Integer.valueOf(asTransId));
							// glog.setDeviceId(asDevId);
							// glog.setUserId(sUserId);
							// glog.setBackupNumber(bkn);
							// glog.insertOrUpdate();
						}
					}
					if (nEnrollDataCount == 0) {
						// sSqlTemp = "INSERT INTO " + csTblUserId;
						// sSqlTemp += "(trans_id, device_id, user_id, backup_number)";
						// sSqlTemp += "VALUES('" + asTransId + "', '";
						// sSqlTemp += asDevId + "', '";
						// sSqlTemp += sUserId + "', ";
						// sSqlTemp += "-1)";
						// DBUtil.update(sSqlTemp, null);
						// KqjgFkcmdTransCmdResultUserIdList glog =
						// KqjgFkcmdTransCmdResultUserIdList.builder().build();
						// glog.setTransId(Integer.valueOf(asTransId));
						// glog.setDeviceId(asDevId);
						// glog.setUserId(sUserId);
						// glog.setBackupNumber(-1);
						// glog.insertOrUpdate();

					}
				} else if ("FKDataHS100".equalsIgnoreCase(sFKDataLib)) {

					FKDataHS100_UserIdInfo usrid = new FKDataHS100_UserIdInfo(bytOneUserId);
					String sUserId = String.valueOf(usrid.UserId);
					int BackupNumber = (int) usrid.BackupNumber;
					// sSqlTemp = "INSERT INTO " + csTblUserId;
					// sSqlTemp += "(trans_id, device_id, user_id, backup_number)";
					// sSqlTemp += "VALUES('" + asTransId + "', '";
					// sSqlTemp += asDevId + "', '";
					// sSqlTemp += sUserId + "', ";
					// sSqlTemp += BackupNumber + ")";
					// DBUtil.update(sSqlTemp, null);
					// KqjgFkcmdTransCmdResultUserIdList glog =
					// KqjgFkcmdTransCmdResultUserIdList.builder().build();
					// glog.setTransId(Integer.valueOf(asTransId));
					// glog.setDeviceId(asDevId);
					// glog.setUserId(sUserId);
					// glog.setBackupNumber(BackupNumber);
					// glog.insertOrUpdate();
				}

			}
			log.i(csFuncName, "7 - HS101");
		} catch (Exception ex) {
			log.e(csFuncName, "error - 2 - " + ex.toString());
			return false;
		}
		log.i(csFuncName, "8");
		return true;
	}

	// 保存命令结果
	private boolean SaveCmdResultLogData(LogUtil log, String asTransId, String asDevId, byte[] abytCmdResult) {
		final String csFuncName = "SaveCmdResultLogData";
		log.i(csFuncName, "3");
		String sFKDataLib = "";

		String sJson;
		byte[] bytLogList;
		Command cmd = new Command();
		GetStringAnd1stBinaryFromBSCommBuffer(abytCmdResult, cmd);
		sJson = cmd.getJsonstr();
		bytLogList = cmd.getBytCmd();
		if (sJson.length() == 0)
			return false;

		log.i(csFuncName, "4");
		int cntLog, sizeOneLog;
		try {
			JSONObject jobjLogInfo = new JSONObject(sJson);
			cntLog = jobjLogInfo.getInt("log_count");
			sizeOneLog = jobjLogInfo.getInt("one_log_size");
			if (bytLogList.length < cntLog * sizeOneLog)
				return false;

			log.i(csFuncName, "5 log count=" + cntLog);
			if (!"FKDataHS101".equalsIgnoreCase(sFKDataLib) && !"FKDataHS100".equalsIgnoreCase(sFKDataLib)) {
				log.e(csFuncName, "error - 1");
				return false;
			}

			if (sizeOneLog != 12)
				return false;

			log.i(csFuncName, "6 - HS101");

			// String sSqlTemp = "DELETE FROM " + csTblLog + " WHERE trans_id='" + asTransId
			// +
			// "' AND device_id='" + asDevId + "'";
			// DBUtil.update(sSqlTemp, null);

			// KqjgFkcmdTransCmdResultLogData.builder().build().delete(
			// new
			// QueryWrapper<KqjgFkcmdTransCmdResultLogData>().lambda().eq(KqjgFkcmdTransCmdResultLogData::getTransId,
			// asTransId)
			// .eq(KqjgFkcmdTransCmdResultLogData::getDeviceId, asDevId));

			int k;
			byte[] bytOneLog = new byte[sizeOneLog];
			for (k = 0; k < cntLog; k++) {
				System.arraycopy(bytLogList, k * sizeOneLog, bytOneLog, 0, sizeOneLog);
				log.i("debug:", "6 - HS101 bytOneLog=" + Arrays.toString(bytOneLog));

				if ("FKDataHS101".equalsIgnoreCase(sFKDataLib)) {
					FKDataHS101_GLog glog = new FKDataHS101_GLog(bytOneLog);
					String sUserId = String.valueOf(glog.UserId);
					String sIoMode = FKDataHS101_GLog.GetInOutModeString(glog.IoMode);
					String sVerifyMode = FKDataHS101_GLog.GetVerifyModeString(glog.VerifyMode);
					String sIoTime = glog.GetIoTimeString();

					// sSqlTemp = "INSERT INTO " + csTblLog;
					// sSqlTemp += "(trans_id, device_id, user_id, verify_mode, io_mode, io_time)";
					// sSqlTemp += "VALUES('" + asTransId + "', '";
					// sSqlTemp += asDevId + "', '";
					// sSqlTemp += sUserId + "', '";
					// sSqlTemp += sVerifyMode + "', '";
					// sSqlTemp += sIoMode + "', '";
					// sSqlTemp += sIoTime + "')";
					// DBUtil.update(sSqlTemp, null);
					// KqjgFkcmdTransCmdResultLogData logdata =
					// KqjgFkcmdTransCmdResultLogData.builder().build();
					// logdata.setTransId(Integer.valueOf(asTransId));
					// logdata.setDeviceId(asDevId);
					// logdata.setUserId(sUserId);
					// logdata.setVerifyMode(sVerifyMode);
					// logdata.setIoMode(sIoMode);
					// logdata.setIoTime(sIoTime);
					// logdata.insertOrUpdate();
				} else if ("FKDataHS100".equalsIgnoreCase(sFKDataLib)) {
					FKDataHS100_GLog glog = new FKDataHS100_GLog(bytOneLog);
					String sUserId = String.valueOf(glog.UserId);
					String sIoMode = FKDataHS100_GLog.GetInOutModeString(glog.IoMode);
					String sVerifyMode = FKDataHS100_GLog.GetVerifyModeString(glog.VerifyMode);
					String sIoTime = glog.GetIoTimeString();
					// sSqlTemp = "INSERT INTO " + csTblLog;
					// sSqlTemp += "(trans_id, device_id, user_id, verify_mode, io_mode, io_time)";
					// sSqlTemp += "VALUES('" + asTransId + "', '";
					// sSqlTemp += asDevId + "', '";
					// sSqlTemp += sUserId + "', '";
					// sSqlTemp += sVerifyMode + "', '";
					// sSqlTemp += sIoMode + "', '";
					// sSqlTemp += sIoTime + "')";
					// DBUtil.update(sSqlTemp, null);
					// KqjgFkcmdTransCmdResultLogData logdata =
					// KqjgFkcmdTransCmdResultLogData.builder().build();
					// logdata.setTransId(Integer.valueOf(asTransId));
					// logdata.setDeviceId(asDevId);
					// logdata.setUserId(sUserId);
					// logdata.setVerifyMode(sVerifyMode);
					// logdata.setIoMode(sIoMode);
					// logdata.setIoTime(sIoTime);
					// logdata.insertOrUpdate();
				}
			}
			log.i(csFuncName, "7 - HS101");
		} catch (Exception ex) {
			log.e(csFuncName, "error - 2 - " + ex.toString());
			return false;
		}
		log.i(csFuncName, "8");
		return true;
	}

	public void GetStringAnd1stBinaryFromBSCommBuffer(byte[] abytBSComm, Command cmd) {
		if (abytBSComm.length < 4)
			return;

		try {
			int lenText = MyUtil.byte2int(abytBSComm);
			if (lenText > abytBSComm.length - 4)
				return;

			if (lenText == 0) {
				cmd.setJsonstr("");
			} else {
				if (abytBSComm[4 + lenText - 1] == 0) // if last value of string buufer is 0x0
					cmd.setJsonstr(MyUtil.byte2String(abytBSComm, 4, lenText - 1));
				else
					cmd.setJsonstr(MyUtil.byte2String(abytBSComm, 4, lenText));
			}

			int posBin = 4 + lenText;
			int lenBin = MyUtil.byte2int(abytBSComm, posBin);
			if (lenBin < 1)
				return;

			if (lenBin > abytBSComm.length - posBin - 4)
				return;

			cmd.setBytCmd(new byte[lenBin]);
			System.arraycopy(abytBSComm, posBin + 4, cmd.getBytCmd(), 0, lenBin);
			return;
		} catch (Exception e) {
			return;
		}
	}
	
	@Value("${config.environmental-science}")
	public String environmental_science;
	
	public void Logoutput(String science) {
		
		if(!("pro").equals(environmental_science)) {
			
			System.out.println(science);
		}else {
			System.out.println("");
		}
		
	}

}
