package com.yl8timer.kqj.yl8timer.entity;

import java.util.HashMap;
import java.util.LinkedList;
import java.util.Map;
import java.util.Queue;

import cn.hutool.json.JSONUtil;

public class Device {
	private String DevId;
	private String fk_name;
	private String fk_time;
	private DeviceInfo devInfo;
	private String fk_info;
	//未执行命令
	public Queue<Command> queue = new LinkedList<Command>(); 
	//等待结果命令
	public  Map<String,Command> cmd = new HashMap<String,Command>();
	
		///在线设备
	public static Map<String,Device> devs = new HashMap<String,Device>();
	public Device() {
	}
	public static Device addDevice(String devId,String devstr) {
		Device dev = JSONUtil.toBean(devstr, Device.class);
		if(devs.containsKey(devId)){
			Device  devr = devs.get(devId);
			devr.setFk_time(dev.getFk_time());
			return devr;
		}else{
			dev.setDevId(devId);
			dev.devInfo = JSONUtil.toBean(dev.fk_info, DeviceInfo.class);
			devs.put(devId,dev);
		} 
		return dev;
	}
	public static int transnum = 1;

	public boolean addCmd(String cmd,String sCmdParam, String transId) {
//		Command cmd1 = new Command("" + transnum++, cmd, null, "OK");
		Command cmd1 = new Command(transId, cmd, null, "OK");
		cmd1.setBytCmd(sCmdParam);
		return queue.offer(cmd1);
	}
	
	public boolean addCmd(String cmd,byte[] bytCmd, String transId) {
//		Command cmd1 = new Command("" + transnum++, cmd, null, "OK");
		Command cmd1 = new Command(transId, cmd, null, "OK");
		cmd1.setBytCmd(bytCmd);
		return queue.offer(cmd1);
	}

	public static Device getDevice(String DevId) {
		if(devs.containsKey(DevId)){
			Device  devr = devs.get(DevId); 
			return devr;
		} 
		return null;
	}
	
	public Command getCmd(){
		try {
			Command c = queue.remove();
			return c;
		} catch (Exception e) {
			 
		} 
		return new Command("","", new byte[0],"ERROR_NO_CMD");
	}

	public Device(String devId, String fk_name, String fk_time, String fk_info) {
		DevId = devId;
		this.fk_name = fk_name;
		this.fk_time = fk_time;
		this.fk_info = fk_info;
	}
	public String getDevId() {
		return DevId;
	}
	public void setDevId(String devId) {
		DevId = devId;
	}
	public String getFk_name() {
		return fk_name;
	}
	public void setFk_name(String fk_name) {
		this.fk_name = fk_name;
	}
	public String getFk_time() {
		return fk_time;
	}
	public void setFk_time(String fk_time) {
		this.fk_time = fk_time;
	}
	public String getFk_info() {
		return fk_info;
	}
	public void setFk_info(String fk_info) {
		this.fk_info = fk_info;
	}
	// {"fk_name":"HUSOON_BS","fk_time":"20191221165759","fk_info":{"supported_enroll_data":["FACE","FP","PASSWORD","IDCARD"],"fk_bin_data_lib":"FKDataHS101","firmware":"Fc601HS","firmware_filename":"Fc601HS","fp_data_ver":112,"face_data_ver":100}}

}
