/**  
* <p>Title: FkCommand.java</p>  
* <p>Description: </p>  
* @author dsc  
* @date 2020年5月6日  
* @version 1.0  
*/
package com.yl8timer.kqj.yl8timer.entity.fk;

import java.util.Date;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * <p>
 * Title: FkCommand.java
 * </p>
 * <p>
 * Description: 考勤机指令实体
 * </p>
 * 
 * @author dsc
 * @date 2020年5月6日
 * @version 1.0
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@Builder
public class FkHsRequest extends Model<FkHsRequest> {

	private static final long serialVersionUID = 6646236303191811803L;

	@TableId(type = IdType.AUTO)
	private Integer id;
	private byte[] totalByte;
	private String devId;
	private String command;
	private Date time;
	private String jsonStr;
	private String status; // OK or ERROR
	private Date runtimes; // 实际运行的时间

}
