package com.yl8timer.kqj.yl8timer.tools;

import org.springframework.beans.factory.annotation.Value;

public class LogUtil {
	private static LogUtil log = null;
	private boolean isDebugMsg = false;
	private LogUtil(boolean isDebugMsg){
		this.isDebugMsg = isDebugMsg;
	}
	public static LogUtil getInstance(boolean isDebugMsg){
		synchronized (LogUtil.class) {
			if(log == null){
				log = new LogUtil(isDebugMsg);
			}
			return log;
		}
	}
	
	public void e(String msg){
		if(isDebugMsg)
			Logoutput("[Error]:"+msg);
	}
	public void e(String type,String msg){
		if(isDebugMsg)
			Logoutput("[Error]:"+type+"---->"+msg);
	}
	public void i(String msg){
		if(isDebugMsg)
			Logoutput("[info]:"+msg);
	}
	public void i(String type,String msg){
		if(isDebugMsg)
			Logoutput("[info]:"+type+"---->"+msg);
	}
	public void t(String tar,String msg){
		if(isDebugMsg)
			Logoutput("[" + tar + "]:" + msg);
	}
	
	@Value("${config.environmental-science}")
	public String environmental_science;
	
	public void Logoutput(String science) {
		
		if(!("pro").equals(environmental_science)) {
			
			System.out.println(science);
		}else {
			System.out.println("");
		}
		
	}
}
